#include <iostream>
#include <type_traits>

#include "if_constexpr.h"

void print_decltype(auto var) {
  std::cout << "variable with value " << var << " is of type ";

  if constexpr (std::is_same<decltype(var), int>::value) {
    std::cout << "int";
  } else if constexpr (std::is_same<decltype(var), double>::value) {
    std::cout << "double";
  } else {
    std::cout << "unknown";
  }

  std::cout << std::endl;
}

void IfConstexprTest::run() {
  print_decltype(23);
  print_decltype(23.5);
  print_decltype("42");
}
